<?php

	/*
		Project_CMS

		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/
	
	$cms_release = '1.0.3';
	
	// Load configuration, if file exists, start installation
	if(file_exists(dirname(__FILE__).'/install.php'))
		include(dirname(__FILE__).'/install.php');
	
	require(dirname(__FILE__).'/config.php');
	
	/*********************************************************************************/
	// For backward compatibility information (Will be removed in a future version)
	if(defined('CMS_CONTENT_TYPE'))
	{
		if(is_writable(dirname(__FILE__).'/config.php'))
		{
			require(CMS_INCLUDE_PATH.'/lib_functions.php');
			$config_content = file_get_contents(dirname(__FILE__).'/config.php');
			$config_content = str_replace('CMS_CONTENT_TYPE', 'CMS_CHARSET', $config_content);
			file_put_contents(dirname(__FILE__).'/config.php', $config_content);
			die('<h1>Configuration updated</h1><p>The configuration file was updated. Please download the current version</p>');
		}
		die('<h1>Please update config</h1><p>Please replace <em>CMS_CONTENT_TYPE</em> by <em>CMS_CHARSET</em> in the configuration file.</p>');		
	}
	/*********************************************************************************/
	
	// Get the base URL of the CMS
	$cms_base_url = 'http'.($_SERVER['HTTPS'] ? 's' : '').'://'.$_SERVER['HTTP_HOST'].
		'/'.str_replace('\\', '/', substr($_SERVER['PHP_SELF'], 0, -strlen(basename($_SERVER['PHP_SELF'])))).'/';
	$cms_base_url = preg_replace('#(?<!:)//+#', '/', $cms_base_url);
	
	// Send out an XML Header if accepted by the user agent
	// Do this before any other stuff as lib_caching could stop the output
	if(preg_match('/application\/xhtml\+xml/i', $_SERVER['HTTP_ACCEPT']))
			header('Content-type: application/xhtml+xml; charset='.CMS_CHARSET);
	elseif(preg_match('/text\/xml/i', $_SERVER['HTTP_ACCEPT']))
			header('Content-type: text/xml; charset='.CMS_CHARSET);
	else	header('Content-type: text/html');
	
	// Libraries
	require(CMS_INCLUDE_PATH.'/lib_functions.php');
	require(CMS_INCLUDE_PATH.'/lib_caching.php');
	require(CMS_INCLUDE_PATH.'/lib_data.php');
	require(CMS_INCLUDE_PATH.'/lib_eventlog.php');
	require(CMS_INCLUDE_PATH.'/lib_templates.php');
	require(CMS_INCLUDE_PATH.'/lib_users.php');
	require(CMS_INCLUDE_PATH.'/lib_articles.php');
	
	// Check directory permissions
	if(!is_writable(CMS_DATA_PATH))
		trigger_error(sprintf(cms_functions::string('index.writepermissions'), CMS_DATA_PATH), E_USER_ERROR);
	
	// Deactivate magic quotes
	if(get_magic_quotes_gpc())
		array_walk_recursive($_REQUEST, create_function('&$value', '$value = stripslashes($value);'));
	@set_magic_quotes_runtime(0);
	
	// Get Requestdata into a standardformat
	array_walk_recursive($_REQUEST, create_function('&$value', '$value = str_replace(array("\r\n", "\r"), "\n", $value);'));
	
	if(!$_REQUEST['mode'])
		$_REQUEST['mode'] = 'view';
	
	// Require the file for the selected modus
	if(!file_exists(CMS_MODES_PATH.'/'.basename($_REQUEST['mode']).'.php'))
		$_REQUEST['mode'] = 'view';
	
	include(CMS_MODES_PATH.'/'.basename($_REQUEST['mode']).'.php');
	
	// Load the index template
	echo(eval($cms_tpl->tpl('index')));
?>