<?php

	/*
		Project_CMS
	
		Installation
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	*/	
	
	// Assume default settings
	define('CMS_PATH', dirname(__FILE__));
	define('CMS_DATA_PATH', CMS_PATH.'/data');
	define('CMS_USER_DATA_FILE', CMS_DATA_PATH.'/.users');
	define('CMS_INCLUDE_PATH', CMS_PATH.'/lib');
	define('CMS_MODES_PATH', CMS_PATH.'/modes');
	define('CMS_TEMPLATE_PATH', CMS_PATH.'/templates');
	define('CMS_USE_MOD_REWRITE', false);
	define('CMS_ACTIVATE_CACHING', true);
	
	// Include required libraries
	require(CMS_INCLUDE_PATH.'/lib_functions.php');
	require(CMS_INCLUDE_PATH.'/lib_data.php');
	require(CMS_INCLUDE_PATH.'/lib_templates.php');

	// Check whether there already is a configuration file
	if(file_exists(dirname(__FILE__).'/config.php'))
		trigger_error('Project CMS is already configured. Please delete install.php.', E_USER_ERROR);
		
	// Errorhandler for installation
	set_error_handler(create_function('', 'return true;'));
	
	// Get the base URL of the CMS
	$cms_base_url = 'http'.($_SERVER['HTTPS'] ? 's' : '').'://'.$_SERVER['HTTP_HOST'].
		'/'.str_replace('\\', '/', substr($_SERVER['PHP_SELF'], 0, -strlen(basename($_SERVER['PHP_SELF'])))).'/';
	$cms_base_url = preg_replace('#(?<!:)//+#', '/', $cms_base_url);
	
	switch($_REQUEST['pos'])
	{
		case '4':
			// Write configuration file
			$configFile = "<?php\n";
			$configFile .= "define('CMS_PATH', dirname(__FILE__));\n";
			$configFile .= "define('CMS_DATA_PATH', CMS_PATH.'/data');\n";
			$configFile .= "define('CMS_USER_DATA_FILE', CMS_DATA_PATH.'/.users');\n";
			$configFile .= "define('CMS_INCLUDE_PATH', CMS_PATH.'/lib');\n";
			$configFile .= "define('CMS_MODES_PATH', CMS_PATH.'/modes');\n";
			$configFile .= "define('CMS_TEMPLATE_PATH', CMS_PATH.'/templates');\n";
			$configFile .= "define('CMS_ADMIN_EMAIL', '".($_REQUEST['settings']['email'])."');\n";
			$configFile .= "define('CMS_USE_MOD_REWRITE', ".($_REQUEST['settings']['rewrite'] ? 'true' : 'false').");\n";
			$configFile .= "define('CMS_ACTIVATE_CACHING', ".($_REQUEST['settings']['caching'] ? 'true' : 'false').");\n";
			$configFile .= "define('CMS_STRIP_WHITESPACE', ".($_REQUEST['settings']['stripWhitespace'] ? 'true' : 'false').");\n";
			$configFile .= "define('CMS_USE_WIKI_FORMATTING', ".($_REQUEST['settings']['wikiFormatting'] ? 'true' : 'false').");\n";
			$configFile .= "define('CMS_ADMIN_USER', '".$_REQUEST['admin']."');\n";
			$configFile .= "define('CMS_USE_HTTP_AUTHENTICATION', ".($_REQUEST['settings']['httpAuth'] ? 'true' : 'false').");\n";
			$configFile .= "define('CMS_CHARSET', '".$_REQUEST['contentType']."');\n";
			$configFile .= "?>";
				
			$pageContent = '<h2>Project_CMS installation - step 4</h2><p>'.
				'The installation is mostly completed. The following steps might have to be done manually:'.
				'<ol>';
				
			if(is_writeable(__FILE__))
			{
				rename(__FILE__, __FILE__.'~');
				$pageContent .= '<li><strong>install.php</strong> was renamed automatically to <strong>install.php~</strong></li>';
			}
			else 
			{
				$pageContent .= '<li>Please delete the file <strong>install.php</strong></li>';
			}
			
			if(is_writable(CMS_PATH) && (is_writable(CMS_PATH.'/config.php') |! file_exists(CMS_PATH.'/config.php')))
			{
				file_put_contents(CMS_PATH.'/config.php', $configFile);
				$pageContent .= '<li><strong>config.php</strong> was written automatically.</li>';
			}
			else 
			{
				$pageContent .= '<li>Save the following '.
					'text as <strong>config.php</strong> into the root directory '.
					'of Project_CMS:'.
					cms_functions::parse_input('<pre>'.$configFile.'</pre>').
					'</li>';
			}
			
			$pageContent .= '</ol><p>Have fun with your <em>Project_CMS</em></p>'.
				'<p>Please submit bugreports to <a href="http://www.pberndt.com">my homepage</a>.</p>';

			break;
			
	case 'testRewrite':
			
			// Mod_rewrite works
			$pageContent = "<h2>Mod_Rewrite test</h2><strong>Mod_rewrite</strong> is supported";
			break;
			
	case 'authtest':
			// Authenticationtest
			if(isset($_SERVER['PHP_AUTH_USER']))
				$pageContent = '<h2>Authenticationtest</h2><p>Test passed, you entered user '.$_SERVER['PHP_AUTH_USER'].' and password '.$_SERVER['PHP_AUTH_PW'].'</p>';
			else 
			{			
				header('HTTP/1.1 401 Unauthorized');
				header('WWW-Authenticate: Basic realm="Testlogin into the CMS"');
				$pageContent = '<h2>Authenticationtest</h2><p>Test <strong>no</strong> passed</p>';
			}
			
			$pageContent .= '<p><a href="javascript:history.back();">Back</a></p>';
			break;
			
		case '3':
			// Create user file
			$userPass = base_convert(rand(1e16, 9e16), 10, 36);
			$userData = array(strtolower($_REQUEST['admin_nick']) => 
							array(
								'pass' => sha1($userPass),
								'permissions' => array(
									'admin' => true,
									'edit' => true)
								));
			
			file_put_contents(CMS_USER_DATA_FILE, serialize($userData));
			
			$pageContent = '<h2>Project_CMS installation - Step 3</h2>'.
				'<p>A userfile was created.</p>'.
				'<div style="padding: 5px; margin: 10px; border: 1px solid #f00; background: #fee">'.
				'Your default user is: <strong>'.$_REQUEST['admin_nick'].'</strong><br/>'.
				'Your password is: <strong>'.$userPass.'</strong>'.
				'</div><p>Please change that passwort after your first login.</p>'.
				'<p>You have to provide a few basic settings, which will be written into '. 
				'<strong>config.php</strong>.</p>'.
				'<form method="post" action="index.php?pos=4&amp;admin='.urlencode(strtolower($_REQUEST['admin_nick'])).'"><p>'.
				'<input type="checkbox" name="settings[httpAuth]" checked="checked" value="1" /> '.
				'Use HTTP authentication <em>(<a href="install.php?pos=authtest">Test it</a> - if httpauth is available on your server you\'ll see a confirmation with any login entered)</em><br/>'.
				'<input type="checkbox" name="settings[stripWhitespace]" value="1" /> '.
				'Strip whitespaces from output <em>(Slower, but saves traffic)</em><br/>'.
				'<input type="checkbox" name="settings[wikiFormatting]" value="1" /> '.
				'Use wiki-format tags <em>(For people not used to HTML. Not adviseable for advanced users)</em><br/>'.
				'<input type="checkbox" name="settings[caching]" value="1" checked="checked" /> '.
				'Cache output<br/>'.
				'<input type="checkbox" name="settings[rewrite]" value="1" checked="checked" /> '.
				'Use <em>Mod_rewrite</em> (<a href="install.html?pos=testRewrite">Test it</a> - You should not see an error here)</p>'.
			'<p><label for="email" class="forInput">Email address to send the logfile to <em>(Leave empty if you do not wish a notification)</em></label><input type="text" id="email" name="settings[email]" class="textInput" /></p>'.
			'<p><label for="contentType" class="forInput">Charset for XML headers <em>(My template uses ISO-8859-1)</em></label><select name="contentType" id="contentType" class="bigInput"><option>iso-8859-1</option><option>iso-8859-15</option><option>utf-8</option></select></p>'.
				'<p><input type="submit" value="Continue" name="continue" /></p></form>';
				
			break;
			
			
		case '2':
			// Ask for a username
			$pageContent = '<h2>Project_CMS installation - step 2</h2>'.
				'<p>Please choose a username for the administratior:</p>'.
				'<form method="post" action="index.php?pos=3"><p>'.
				'<label for="admin_nick" class="forInput">Nick</label>'.
				'<input type="text" name="admin_nick" id="admin_nick" value="Admin" />'.
				'<input type="submit" name="ok" value="Ok"/></p></form>';
			
			break;
			
		default:
			// Statusinformation &
			// requirements
			
			// PHP version
			if(floatval(phpversion()) > 4.2)
				$statusMessages['PHP version'] = 'Passed ('.phpversion().')';
			else 
				$statusMessages['PHP version'] = 'Too old ('.phpversion().')';
			
			// Is ./data writeable?
			$uriPathOfDataPath = substr(CMS_DATA_PATH, strlen($_SERVER['DOCUMENT_ROOT']));
			$dataPathWriteable = is_writable(CMS_DATA_PATH);
			foreach(cms_functions::get_dir(CMS_DATA_PATH) as $file)
			{
				$dataPathWriteable &= is_writeable(CMS_DATA_PATH.'/'.$file);
			}
			if($dataPathWriteable)
				$statusMessages['Path <strong>'.$uriPathOfDataPath.'</strong> and subdirectories writeable'] = 'Passed';
			else 
				$statusMessages['Path <strong>'.$uriPathOfDataPath.'</strong> and subdirectories writeable'] = 'Not writeable';
			
			// Open access to ./data/
			if(function_exists('fsockopen'))
			{
				if(!file_exists(CMS_USER_DATA_FILE))
					file_put_contents(CMS_USER_DATA_FILE, "-new user file-");
				
				$uriPathOfUserData = substr(CMS_USER_DATA_FILE, strlen($_SERVER['DOCUMENT_ROOT']));
			
				$localhost = @fsockopen('localhost', 80);
				fputs($localhost, 'HEAD '.str_replace(' ', '%20', $uriPathOfUserData).' HTTP/1.1'."\r\n");
				fputs($localhost, 'Host: '.$_SERVER['SERVER_NAME']."\r\n\r\n");
				$localhostAccess = fgets($localhost);
				fclose($localhost);
				
				if(strpos($localhostAccess, ' 4') === false && strpos($localhostAccess, ' 5') === false)
					$statusMessages['Userfile <strong>'.$uriPathOfUserData.'</strong> not accessible'] = 'Access possible';
				else
					$statusMessages['Userfile <strong>'.$uriPathOfUserData.'</strong> not accessible'] = 'Passed';
			}
			
			// Sockets
			if($localhost)
				$statusMessages['Socketconnections possible'] = 'Passed';
			else 
				$statusMessages['Socketconnections possible'] = 'Denied';
				
			// Output information page
			$pageContent = '<h2>Project_CMS installation - Step 1</h2>'.
				'<p>Welcome to the Project_CMS installation. Please follow this '.
				'installation guide exactly to ensure having a secure system.'.
				'</p><table summary="Requirements for installation">'.
				'<tr><th>Requirement</th><th>Result</th></tr>';
				
			$okay = true;
			foreach($statusMessages as $voraussetzung => $value)
			{
				$okay &= $value[0] == 'P';
				$color = $value[0] != 'P' ? '#ff0000' : '#008800';
				$pageContent .= '<tr><td>'.$voraussetzung.'</td><td style="color:'.$color.'">'.$value.'</td></tr>';
			}
		
			if(!$okay)
				 $pageContent .= '</table><p>Please change your serversettings according to the result table. If you whish to ignore the errors, click the following link:</p>';
			else $pageContent .= '</table>';
			
			$pageContent .= '<p><a href="index.php?pos=2">Begin installation</a></p>';
			
			break;
	}
	
	$pageTitle = 'Installation';
	echo(eval($cms_tpl->tpl('index')));
	
	die();
?>