<?php

	/*
		Script Highlight [with support for phpBB]
		Version 1.2
		[PHP4 compatible Version]
		
		**************************************************************************
		
		Copyright (c) 2005 by Phillip 'Firebird' Berndt
		www.pberndt.com
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
		
		For a full copy of the GPL visit
		http://www.gnu.org/licenses/gpl.txt
		
		**************************************************************************
		
		Install instructions:
		
		1) Copy this file to './includes/highlight_code.php'
		2) Open bbcode.php
		3) Search for a function called "bbencode_second_pass"
		4) Search for the line
			$text = bbencode_second_pass_code($text, $uid, $bbcode_tpl);
		5) Replace it by
			require_once('./includes/highlight_code.php');
			$text = bbencode_do_highlight($text, $uid, $bbcode_tpl);
		6) Open overall_header.tpl and simple_header.tpl
		7) Add to _the top_ of the <style> .. </style> area:
			@import url("includes/highlight_code.php");
		
	*/
	
	/** The highlighter class ****************************************************/
	
	class highlighter
	{
		// Remember:
		// Although php4 allows you to access these properties directly
		// you should NOT.
		
		// The text which gets parsed
		var $text;
		// The parsed result
		var $parsed;
		// An array storing the keywords
		var $keywords;
		// A boolean value which changes this classes behavior because of
		// a few peculiarities of phpBB...
		var $inPhpBB;
		
		
		
		/**
		* Creates a new highlighter class
		*
		* @return void
		*/
		function highlighter()
		{
			// Generic keywords
			$this->keywords = array(
				// Data Types / Java / PHP
				'byte', 'short', 'int', 'long', 'boolean', 'char', 'float', 'double',
				'break', 'continue', 'do', 'while', 'for', 'if', 'else', 'elif', 'switch', 
				'case', 'default', 'throw', 'try', 'catch', 'finally', 'class', 'extends',
				'implements', 'instanceof', 'interface', 'new', 'super', 'this', 'return',
				'void', 'abstract', 'private', 'public', 'protected', 'final', 'static',
				'throws', 'throw', 'import', 'package', 'native', 'synchronized', 
				'transient', 'volatile', 'and', 'or', 'xor', 'not', 'array', '__\S+__', 'const', 'default', 'die', 'echo',
				'elseif', 'endif', 'endwhile', 'enddeclare', 'endforeach', 'endswitch', 'endfor',
				'foreach', 'eval', 'unset', 'require', 'include', 'require_once', 'include_once', 
				'list', 'global', 'as', 'function', 'var', 'isset', 'true', 'false',
				
				// HTML elements
				'a', 'abbr', 'acronym', 'address', 'applet', 'area', 'b', 
				'base', 'basefont', 'bdo', 'big', 'blockquote', 'body', 
				'br', 'button', 'caption', 'center', 'cite', 'code', 
				'col', 'colgroup', 'dd', 'del', 'dfn', 'dir', 
				'div', 'dl', 'dt', 'em', 'fieldset', 'font', 
				'form', 'frame', 'frameset', 'h1', 'h2', 'h3', 
				'h4', 'h5', 'h6', 'head', 'hr', 'html', 
				'i', 'iframe', 'img', 'input', 'ins', 'isindex', 
				'kbd', 'label', 'legend', 'li', 'link', 'map', 
				'menu', 'meta', 'noframes', 'noscript', 'object', 'ol', 
				'optgroup', 'option', 'p', 'param', 'pre', 'q', 
				's', 'samp', 'script', 'select', 'small', 'span', 
				'strike', 'strong', 'style', 'sub', 'sup', 'table', 
				'tbody', 'td', 'textarea', 'tfoot', 'th', 'thead', 
				'title', 'tr', 'tt', 'u', 'ul', 'var', 'end', 'dim',
				
				// HTML attributes
				'abbr', 'accept-charset', 'accept', 'accesskey', 'action', 'align', 'alink', 
				'alt', 'archive', 'axis', 'background', 'bgcolor', 'border', 
				'cellpadding', 'cellspacing', 'char', 'charoff', 'charset', 'checked', 
				'cite', 'class', 'classid', 'clear', 'code', 'codebase', 
				'codetype', 'color', 'cols', 'colspan', 'compact', 'content', 
				'coords', 'data', 'datetime', 'declare', 'defer', 'dir', 
				'disabled', 'enctype', 'face', 'for', 'frame', 'frameborder', 
				'headers', 'height', 'href', 'hreflang', 'hspace', 'http-equiv', 
				'id', 'ismap', 'label', 'lang', 'language', 'link', 
				'longdesc', 'marginheight', 'marginwidth', 'maxlength', 'media', 'method', 
				'multiple', 'name', 'nohref', 'noresize', 'noshade', 'nowrap', 
				'object', 'onblur', 'onchange', 'onclick', 'ondblclick', 'onfocus', 
				'onkeydown', 'onkeypress', 'onkeyup', 'onload', 'onmousedown', 'onmousemove', 
				'onmouseout', 'onmouseover', 'onmouseup', 'onreset', 'onselect', 'onsubmit', 
				'onunload', 'profile', 'prompt', 'readonly', 'rel', 'rev', 
				'rows', 'rowspan', 'rules', 'scheme', 'scope', 'scrolling', 
				'selected', 'shape', 'size', 'span', 'src', 'standby', 
				'start', 'style', 'summary', 'tabindex', 'target', 'text', 
				'title', 'type', 'usemap', 'valign', 'value', 'valuetype', 
				'version', 'vlink', 'vspace', 'width', 'onclick', 'onmouseover', 'onmouseout',
				'onfocus', 'onblur', 'onchange', 'onkeypress', 'onkeydown', 'onkeyup',
				
				// SQL
				'select', 'insert', 'update', 'delete', 'grant', 'where', 'union', 'join',
				'left', 'inner', 'right', 'group', 'order', 'by', 'from', 'limit'
			);
		}
		
		/**
		* Adds default keywords to the keyword list
		*
		* 3 is for CSS
		* 2 is for SQL
		* 1 is for PHP
		*
		* @return void
		* @param int $whichKeywords
		*/
		function add_default_keywords($whichKeywords)
		{
			switch($whichKeywords)
			{
				// CSS
				case 3:
					$addKeywords = array('azimuth', 'angle', 'left', 
					'center', 'right', 'leftwards', 'rightwards', 'inherit', 
					'aural', 'background-attachment', 'scroll', 'fixed', 'visual', 
					'background-color', 'color', 'transparent', 'background-image', 'uri', 
					'none', 'background-position', 'percentage', 'length', 'top', 
					'background-repeat', 'repeat', 'background', 'border-collapse', 'collapse', 
					'separate', 'border-color', 'border-spacing', 'border-style', 'border-top', 
					'border-right', 'border-bottom', 'border-left', 'border-width', 'border-top-color', 
					'border-right-color', 'border-bottom-color', 'border-left-color', 'border-top-style', 'border-right-style', 
					'border-bottom-style', 'border-left-style', 'border-top-width', 'border-right-width', 'border-bottom-width', 
					'border-left-width', 'border', 'bottom', 'auto', 'caption-side', 
					'clear', 'both', 'clip', 'shape', 'content', 
					'normal', 'string', 'counter', 'identifier', 'all', 
					'counter-increment', 'integer', 'counter-reset', 'cue-after', 'cue-before', 
					'cue', 'cursor', 'crosshair', 'default', 'pointer', 
					'move', 'text', 'wait', 'help', 'interactive', 
					'direction', 'ltr', 'rtl', 'display', 'inline', 
					'block', 'table', 'elevation', 'below', 'level', 
					'above', 'higher', 'lower', 'empty-cells', 'show', 
					'hide', 'float', 'font-family', 'family-name', 'generic-family', 
					'font-size', 'absolute-size', 'relative-size', 'font-style', 'italic', 
					'oblique', 'font-variant', 'font-weight', 'bold', 'bolder', 
					'lighter', 'font', 'line-height', 'caption', 'icon', 
					'menu', 'height', 'letter-spacing', 'number', 'list-style-image', 
					'list-style-position', 'inside', 'outside', 'list-style-type', 'disc', 
					'circle', 'square', 'decimal', 'armenian', 'georgian', 
					'list-style', 'margin-right', 'margin-left', 'margin-width', 'margin-top', 
					'margin-bottom', 'margin', 'max-height', 'max-width', 'min-height', 
					'min-width', 'orphans', 'paged', 'outline-color', 'invert', 
					'outline-style', 'outline-width', 'outline', 'overflow', 'visible', 
					'hidden', 'padding-top', 'padding-right', 'padding-bottom', 'padding-left', 
					'padding-width', 'padding', 'page-break-after', 'always', 'avoid', 
					'page-break-before', 'page-break-inside', 'pause-after', 'time', 'pause-before', 
					'pause', 'pitch-range', 'pitch', 'frequency', 'low', 
					'medium', 'high', 'play-during', 'position', 'static', 
					'relative', 'absolute', 'quotes', 'richness', 'speak-header', 
					'once', 'speak-numeral', 'digits', 'continuous', 'speak-punctuation', 
					'code', 'speak', 'speech-rate', 'slow', 'fast', 
					'faster', 'slower', 'stress', 'table-layout', 'text-align', 
					'justify', 'text-decoration', 'overline', 'text-indent', 'text-transform', 
					'capitalize', 'uppercase', 'lowercase', 'unicode-bidi', 'embed', 
					'vertical-align', 'baseline', 'sub', 'super', 'middle', 
					'visibility', 'voice-family', 'specific-voice', 'generic-voice', 'volume', 
					'silent', 'soft', 'loud', 'white-space', 'pre', 
					'nowrap', 'widows', 'width', 'word-spacing', 'z-index', 'url', '(?<=\s|^)@\S+'
					);
					break;
					
				// SQL
				case 2:
					$addKeywords = array(
					'abort', 'abs', 'absolute', 'access', 'action', 'ada', 'add', 
					'admin', 'after', 'aggregate', 'alias', 'all', 'allocate', 
					'alter', 'analyse', 'analyze', 'and', 'any', 'are', 
					'array', 'as', 'asc', 'asensitive', 'assertion', 'assignment', 
					'asymmetric', 'at', 'atomic', 'authorization', 'avg', 'backward', 
					'before', 'begin', 'between', 'binary', 'bit', 'bitvar', 
					'bit_length', 'blob', 'boolean', 'both', 'breadth', 'by', 
					'c', 'cache', 'call', 'called', 'cardinality', 'cascade', 
					'cascaded', 'case', 'cast', 'catalog', 'catalog_name', 'chain', 
					'char', 'character', 'characteristics', 'character_length', 'character_set_catalog', 'character_set_name', 
					'character_set_schema', 'char_length', 'check', 'checked', 'checkpoint', 'class', 
					'class_origin', 'clob', 'close', 'cluster', 'coalesce', 'cobol', 
					'collate', 'collation', 'collation_catalog', 'collation_name', 'collation_schema', 'column', 
					'column_name', 'command_function', 'command_function_code', 'comment', 'commit', 'committed', 
					'completion', 'condition_number', 'connect', 'connection', 'connection_name', 'constraint', 
					'constraints', 'constraint_catalog', 'constraint_name', 'constraint_schema', 'constructor', 'contains', 
					'continue', 'convert', 'copy', 'corresponding', 'count', 'create', 
					'createdb', 'createuser', 'cross', 'cube', 'current', 'current_date', 
					'current_path', 'current_role', 'current_time', 'current_timestamp', 'current_user', 'cursor', 
					'cursor_name', 'cycle', 'data', 'database', 'date', 'datetime_interval_code', 
					'datetime_interval_precision', 'day', 'deallocate', 'dec', 'decimal', 'declare', 
					'default', 'deferrable', 'deferred', 'defined', 'definer', 'delete', 
					'delimiters', 'depth', 'deref', 'desc', 'describe', 'descriptor', 
					'destroy', 'destructor', 'deterministic', 'diagnostics', 'dictionary', 'disconnect', 
					'dispatch', 'distinct', 'do', 'domain', 'double', 'drop', 
					'dynamic', 'dynamic_function', 'dynamic_function_code', 'each', 'else', 'encoding', 
					'end', 'end-exec', 'equals', 'escape', 'every', 'except', 
					'exception', 'exclusive', 'exec', 'execute', 'existing', 'exists', 
					'explain', 'extend', 'external', 'extract', 'false', 'fetch', 
					'final', 'first', 'float', 'for', 'force', 'foreign', 
					'fortran', 'forward', 'found', 'free', 'from', 'full', 
					'function', 'g', 'general', 'generated', 'get', 'global', 
					'go', 'goto', 'grant', 'granted', 'group', 'grouping', 
					'handler', 'having', 'hierarchy', 'hold', 'host', 'hour', 
					'identity', 'ignore', 'ilike', 'immediate', 'implementation', 'in', 
					'increment', 'index', 'indicator', 'infix', 'inherits', 'initialize', 
					'initially', 'inner', 'inout', 'input', 'insensitive', 'insert', 
					'instance', 'instantiable', 'instead', 'int', 'integer', 'intersect', 
					'interval', 'into', 'invoker', 'is', 'isnull', 'isolation', 
					'iterate', 'join', 'k', 'key', 'key_member', 'key_type', 
					'lancompiler', 'language', 'large', 'last', 'lateral', 'leading', 
					'left', 'length', 'less', 'level', 'like', 'limit', 
					'listen', 'load', 'local', 'localtime', 'localtimestamp', 'location', 
					'locator', 'lock', 'lower', 'm', 'map', 'match', 
					'max', 'maxvalue', 'message_length', 'message_octet_length', 'message_text', 'method', 
					'min', 'minute', 'minvalue', 'mod', 'mode', 'modifies', 
					'modify', 'module', 'month', 'more', 'move', 'mumps', 
					'name', 'names', 'national', 'natural', 'nchar', 'nclob', 
					'new', 'next', 'no', 'nocreatedb', 'nocreateuser', 'none', 
					'not', 'nothing', 'notify', 'notnull', 'null', 'nullable', 
					'nullif', 'number', 'numeric', 'object', 'octet_length', 'of', 
					'off', 'offset', 'oids', 'old', 'on', 'only', 
					'open', 'operation', 'operator', 'option', 'options', 'or', 
					'order', 'ordinality', 'out', 'outer', 'output', 'overlaps', 
					'overlay', 'overriding', 'owner', 'pad', 'parameter', 'parameters', 
					'parameter_mode', 'parameter_name', 'parameter_ordinal_position', 'parameter_specific_catalog', 'parameter_specific_name', 'parameter_specific_schema', 
					'partial', 'pascal', 'password', 'path', 'pendant', 'pli', 
					'position', 'postfix', 'precision', 'prefix', 'preorder', 'prepare', 
					'preserve', 'primary', 'prior', 'privileges', 'procedural', 'procedure', 
					'public', 'read', 'reads', 'real', 'recursive', 'ref', 
					'references', 'referencing', 'reindex', 'relative', 'rename', 'repeatable', 
					'reset', 'restrict', 'result', 'return', 'returned_length', 'returned_octet_length', 
					'returned_sqlstate', 'returns', 'revoke', 'right', 'role', 'rollback', 
					'rollup', 'routine', 'routine_catalog', 'routine_name', 'routine_schema', 'row', 
					'rows', 'row_count', 'rule', 'savepoint', 'scale', 'schema', 
					'schema_name', 'scope', 'scroll', 'search', 'second', 'section', 
					'security', 'select', 'self', 'sensitive', 'sequence', 'serial', 
					'serializable', 'server_name', 'session', 'session_user', 'set', 'setof', 
					'sets', 'share', 'show', 'similar', 'simple', 'size', 
					'smallint', 'some', 'source', 'space', 'specific', 'specifictype', 
					'specific_name', 'sql', 'sqlcode', 'sqlerror', 'sqlexception', 'sqlstate', 
					'sqlwarning', 'start', 'state', 'statement', 'static', 'stdin', 
					'stdout', 'structure', 'style', 'subclass_origin', 'sublist', 'substring', 
					'sum', 'symmetric', 'sysid', 'system', 'system_user', 'table', 
					'table_name', 'temp', 'template', 'temporary', 'terminate', 'than', 
					'then', 'time', 'timestamp', 'timezone_hour', 'timezone_minute', 'to', 
					'toast', 'trailing', 'transaction', 'transactions_committed', 'transactions_rolled_back', 'transaction_active', 
					'transform', 'transforms', 'translate', 'translation', 'treat', 'trigger', 
					'trigger_catalog', 'trigger_name', 'trigger_schema', 'trim', 'true', 'truncate', 
					'trusted', 'type', 'uncommitted', 'under', 'union', 'unique', 
					'unknown', 'unlisten', 'unnamed', 'unnest', 'until', 'update', 
					'upper', 'usage', 'user', 'user_defined_type_catalog', 'user_defined_type_name', 'user_defined_type_schema', 
					'using', 'vacuum', 'valid', 'value', 'values', 'varchar', 
					'variable', 'varying', 'verbose', 'version', 'view', 'when', 
					'whenever', 'where', 'with', 'without', 'work', 'write', 
					'year', 'zone');
					break;
					
				// PHP Functions
				case 1:
					$addKeywords = get_defined_functions();
					$addKeywords = $addKeywords['internal'];
					break;
			}
			
			$this->addKeywords($addKeywords);
		}
		
		/**
		* Add one or a couple of keywords
		*
		* You may use an array or a string as an argument
		*
		* @return void
		* @param mixed $keywords
		*/
		function addKeywords($keywords)
		{
			if(is_array($keywords))
				$this->keywords = array_merge($this->keywords, $keywords);
			elseif(is_string($keywords))
				$this->keywords[] = $keywords;
			else trigger_error('This is neither an array nor a string', E_USER_WARNING);
		}
		
		/**
		* Changes the classes behavior so that phpBB specific stuff is handled correctly
		*
		* phpBB needs some special behavior (it executes nl2br after the processing of [code])
		*
		* @return void
		* @param bool $set
		*/
		function inPhpBB($set)
		{
			$this->inPhpBB = is_bool($set) ? $set : false;
		}
		
		/**
		* Highlights tags. For internal use only.
		*
		* @return void
		*/
		function &hl_tags()
		{
			// For correct handling of "\\", we need to convert \\ to html entities
			$this->parsed = str_replace('\\\\', '&#92;&#92;', $this->parsed);
			
			// All kinds of texts		
			$pcre 		  = '/(^|\s|\.|\(|\+|\=|\[|,|;|:)(&quot;|\'|`)(.*)(?<!\\\\)\\2/siU';
			$pcre_replace = '$1$2<span class="text">$3</span>$2';
			$this->parsed = preg_replace($pcre, $pcre_replace, $this->parsed);
			
			// Heredoc notation of texts
			$pcre 		  = '/(^|\s|\.|\(|\+|\=|\[|,|;)&lt;&lt;&lt;(\S+)(.+)'."(\n\\2;?(?:\n|\$))/sU";
			$pcre_replace = '$1<span class="text">&lt;&lt;&lt;$2$3$4</span>';
			$this->parsed = preg_replace($pcre, $pcre_replace, $this->parsed);
			
			// Script tags
			$this->parsed = preg_replace('/&lt;\/?script.*&gt;/siU', '<span class="tag">$0</span>', $this->parsed);
			
			// Code Tags
			$this->parsed = preg_replace('/(&lt;\?(php)?=?|\?&gt;|&lt;%=?|%&gt;)/si', '<span class="codetag">$0</span>', $this->parsed);			
			
			// Code Tags
			$this->parsed = preg_replace('/(&lt;\?(php)?=?|\?&gt;|&lt;%=?|%&gt;)/si', '<span class="codetag">$0</span>', $this->parsed);			
			
			// Unknown XML Tags
			$this->parsed = preg_replace('/(?!<>)(&lt;\/?)([a-z0-9\-\._:]+?)((?:\s.+?)?&gt;)/si', '$1<span class="unknowntag">$2</span>$3', $this->parsed);

			return $this->parsed;
		}
		
		/**
		* Highlights keywords & numbers. For internal use only.
		*
		* @return void
		*/
		function hl_keywords()
		{
			// Highlight Keywords
			$keyword_pcre = implode('|', array_unique($this->keywords));
			/*$pcre		  = '/(\s|^|,|\)|\(|{|;|}|&lt;\/?|=|\s:|\?)('.$keyword_pcre.')(?=\s|$|,|=|\(|\)|;|:|\.|{|}|&gt;|\/)/siU';
			$pcre_replace = '$1<span class="keyword">$2</span>';*/
			$pcre		  = '/(?<=\s|^|,|\)|\(|{|;|}|&lt;|&lt;\/|=|\s:|\?)('.$keyword_pcre.')(?=\s|$|,|=|\(|\)|;|:|\.|{|}|&gt;|\/)/siU';
			$pcre_replace = '<span class="keyword">$1</span>';
			
			$this->parsed = preg_replace($pcre, $pcre_replace, $this->parsed);
			
			// Highlight numbers
			$this->parsed = preg_replace('/(\s|^|,|\)|\(|{|;|}|&lt;\/?|=)((?:\-|\+)?(?!0)(?:[0-9]+e[0-9]+\.[0-9]+|[0-9]+\.[0-9]+|[0-9]+e[0-9]+|[0-9]+)(?:px|em|cm|%|in|mm|pt|pc|ex)?)(?=\s|$|,|=|\(|\)|;|:|{|}|&gt;|\/)/siU', '$1<span class="number" title="Dezimalzahl">$2</span>$3', $this->parsed);
			$this->parsed = preg_replace('/(\s|^|,|\)|\(|{|;|}|&lt;\/?|=)((?:\-|\+)?0(?:[0-9]+e[0-9]+\.[0-9]+|[0-9]+\.[0-9]+|[0-9]+e[0-9]+|[0-9]*)(?:px|em|cm|%|in|mm|pt|pc|ex)?)(?=\s|$|,|=|\(|\)|;|:|{|}|&gt;|\/)/seiU', '\'$1<span class="number" title="Oktalzahl, Dezimaldarstellung: \'.(octdec(\'$2\') > 017777777777 ? \'mehr als 2147483647\' : octdec(\'$2\')).\'">$2</span>$3\'', $this->parsed);
			$this->parsed = preg_replace('/(\s|^|,|\)|\(|{|;|}|&lt;\/?|=)((?:\-|\+)?0x(?:[0-9a-f]+e[0-9a-f]+\.[0-9a-f]+|[0-9a-f]+\.[0-9a-f]+|[0-9a-f]+e[0-9a-f]+|[0-9a-f]+))(?=\s|$|,|=|\(|\)|;|:|{|}|&gt;|\/)/sieU', '\'$1<span class="number" title="Hexadezimalzahl, Dezimaldarstellung: \'.(hexdec(\'$2\') > 0x7fffffff ? \'mehr als 2147483647\' : hexdec(\'$2\')).\'">$2</span>$3\'', $this->parsed);
			
			return $this->parsed;
		}
		
		/**
		* Highlights comments. For internal use only.
		*
		* @return void
		*/
		function hl_comments()
		{
			// HTML comments are deactivated since some scripts use them - highlighting
			// would get auto-deactivated
			// $pcre 		  = '/(&lt;!--.+--&gt;|\/\*.+\*\/|\/\/.+\n|\n#.+\n)/siU';
			
			$pcre 		  = '/(?:\/\*.+\*\/|(?<=\s|^|;)(?:\/\/|REM ).*(?=\n|$)|(?<=\n|^)(?:#|\'|;).*(?=\n|$)|(?<=\n|^)\s+(?:#|\') .*(?=\n|$))/siU';
			$pcre_replace = '<span class="comment">$0</span>';
			$this->parsed = preg_replace($pcre, $pcre_replace, $this->parsed);
		}
		
		/**
		* Highlights entities and colors. For internal use only.
		*
		* @return void
		*/
		function hl_entities()
		{
			// HTML entities and PHP Variables
			$pcre 		  = '/&amp;\S+(?<!&amp);|\$[A-Z0-9_\->]+?/iU';
			$pcre_replace = '<span class="entity">$0</span>';
			$this->parsed = preg_replace($pcre, $pcre_replace, $this->parsed);
					
			// Any other HTML related stuff here
			// Colors
			$pcre 		  = '/#([0-9A-F]{6}|[0-9A-F]{3})(?![0-9A-F])/i';
			$pcre_replace = '<span class="htmlColor" onmouseover="this.firstChild.style.color=\'$0\'" onclick="this.style.backgroundColor=this.style.color=\'$0\';" onmouseout="this.style.backgroundColor=this.style.color=\'\';this.firstChild.style.color=\'\';"><span>#</span>$1</span>';
			$this->parsed = preg_replace($pcre, $pcre_replace, $this->parsed);
			
		}

		/**
		* Highlights a given string.
		*
		* Note that the parameter has to be plain text, without
		* any command like htmlspecialchars() applied.
		*
		* @return void
		* @param string[optional] $text
		*/	
		function parse($text = -1)
		{
			// Set text to parse
			if($text == -1)
				$text = $this->text;
			else 
				$this->text = $text;
						
			// Set $parsed to zero
			$this->parsed = $this->text;
			// The str_replace is needed for compatibility with old versions of project_cms
			$this->parsed = str_replace("\r\n", "\n", $this->parsed);
			$parsed = &$this->parsed;
			
			// Convert > and <
			$parsed = str_replace(array('&', '<', '>'), array('&amp;', '&lt;', '&gt;'), $parsed);
			$parsed = str_replace('"', '&quot;', $parsed);
			
			// Rewrite PHP's ugly 'echo"Foo";' to 'echo "Foo";'
			$this->parsed = preg_replace('/(\s|^|,|\)|\(|{|;|}|&lt;\/?|=)(echo)(&quot;|\')/i', '$1$2 $3', $this->parsed);
			
			// Parse text
			$this->hl_keywords();
			$this->hl_comments();
			$this->hl_tags();
			$this->hl_entities();
			
			// Convert special chars
			$parsed = str_replace('  ', '&nbsp; ', $parsed);
			$parsed = str_replace("\t", '&nbsp; <span class="ws">&#9;</span> ', $parsed);
			if(!$this->inPhpBB)
				$parsed = nl2br($parsed);
			
			// Return text
			return $this->parsed;
		}

		/**
		* Output a default CSS file for highlighting
		*
		* Note: This function does not send a content-type header
		* You might want to change the colors anyway ;)
		*
		* @return void
		*/	
		function put_default_css()
		{
			?>
				/*
					PhpBB Highlight Script
					Copyright (c) by Phillip 'Firebird' Berndt
					www.pberndt.com
				*/
				.highlight
				{
					color: #000;
					font-family: monospace;
				}
				
				div.highlight
				{
					white-space: nowrap;
				}
				
				div.highlight .lines
				{
					color: #777;
					font-size: 8pt;
					font-size: 11px;
					display: block;
					float: left;
					padding-right: 5px;
				}
				
				div.highlight code
				{
					color: #000;
					font-size: 8pt;
					font-size: 11px;
					white-space: nowrap;
				}
				
				.highlight .keyword
				{
					color: #00F;
				}
				
				.highlight .ws
				{
					white-space: pre;
				}
				
				.highlight .unknowntag
				{
					color: #00589C;
				}
				
				.highlight .entity
				{
					color: #600;
				}
				
				.highlight .codetag
				{
					color: #644;
				}
				
				.highlight .number
				{
					color: #E00;
				}
				
				.highlight .comment, .highlight .comment .tag, .highlight .comment .text, .highlight .comment .text .keyword, .highlight .comment .code, .highlight .comment .keyword, .highlight .comment .entity, .highlight .comment .number, .highlight .comment .codetag, .highlight .comment .unknowntag, .highlight .comment a
				{
					color: #444;
				}
				
				.highlight .text, .highlight .text .comment, .highlight .text .tag, .highlight .text .keyword, .highlight .text .code, .highlight .text .entity, .highlight .text .number, .highlight .text .codetag, .highlight .text .unknowntag, .highlight .comment .unknowntag, .highlight .text a
				{
					color: #006400;
				}
				
				.highlight .code, .highlight .code a
				{
					color: #222;
					border: none;
				}	
				
				.highlight .htmlColor
				{
					cursor: pointer;
				}		
				
				.highlight a
				{
					text-decoration: underline;
				}		
			<?
			
			// Special CSS orders for IE & Opera as they seem to have a problem
			// with white-space:nowrap
			if(preg_match('/(?:MSIE|Opera)/i', $_SERVER['HTTP_USER_AGENT']))
			{
			?>
				/* MSIE & Opera CSS */
				div.highlight .lines
				{
					position: absolute;
				}
				
				div.highlight code
				{
					padding-left: 30px;
					display: block;
				}
				
				div.highlight code.oneLiner
				{
					padding-left: 0px;
					display: inherit;
				}
			<?php
			}
			
		}
	}
	
	
	/** Functions for usage in phpBB *********************************************/

	/**
	* Callback function for bbencode_do_highlight
	*
	* This is a callback for preg_replace_callback()
	*
	* @return string
	* @param array $cb_data
	*/	
	function bbencode_highlight_callback($cb_data)
	{
		global $db;
		
		static $bbcode_tpl;
		if(!$bbcode_tpl)
		{
			$bbcode_tpl = $cb_data;
			return;
		}
		
		static $highlight;
		if(!$highlight)
		{
			$highlight = new highlighter();
			$highlight->add_default_keywords(3);
			$highlight->inPhpBB(true);
		}
		
		// Read code
		$text = $cb_data[1];
		$highlighting = true;
		
		$text = trim($text);
		
		// We need the plain code, so revoke HTML replacements
		$text = html_entity_decode($text);
		$text = preg_replace('/&#([0-9]{1,4});/ie', '@chr($1)', $text);
		
		// Remove leading empty line
		if(substr($text, 0, 1) == chr(13)) $text = substr($text, 2);

		if($highlighting)
				$text = $highlight->parse($text);
		else $text = htmlspecialchars($text);
		
		// Remove leading empty line
		if(substr($text, 0, 1) == chr(13)) $text = substr($text, 2);
				
		// Encode Smilies
		$sql = 'SELECT * FROM ' . SMILIES_TABLE;
		if( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't obtain smilies data", "", __LINE__, __FILE__, $sql);
		}
		$smilies = $db->sql_fetchrowset($result);
		
		foreach($smilies as $smilie)
		{
			$smilie_encoded = '';
			for($i=0;$i<strlen($smilie['code']);$i++) $smilie_encoded .= '&#'.ord($smilie['code'][$i]).';';
			$text = preg_replace('/(?<!&quot)'.preg_quote($smilie['code'], '/').'/', $smilie_encoded, $text);
		}
		
		// We need some code to verify that URL's BBCode doesn't apply here
			$text = str_replace('[', '&#'.ord('[').';', $text);
			$text = str_replace(']', '&#'.ord(']').';', $text);
									
		// Add line numbers
		$lines = '';
		foreach(split("<br|\r?\n|\r", $text) as $line)
			$lines .= (str_pad(++$lineNumber, 3, '0', STR_PAD_LEFT).'<br/>');
		
		// Define Height for Code Tag
		$blockHeight = ($lineNumber < 25 ? 'max-' : '').'height:400px';
		$overFlow	 = 'overflow:auto;';
		
		// Just for IE, which has problems with too small code tags
		if(preg_match('/MSIE.*\)(?!Opera .*)$/', $_SERVER['HTTP_USER_AGENT']) &&
			$lineNumber < 2)
			{
				$blockHeight = 'height:36px';
				$overFlow	 = 'overflow:scroll;';
			}	

		// For one-liners don't use line numbers
		if($lineNumber < 2) $lines = '';
		
		// Define an id for this code block
		if(!isset($GLOBALS['highlighter_codeTagId']))
				$GLOBALS['highlighter_codeTagId'] = 0;
		$codeTagId = ++$GLOBALS['highlighter_codeTagId'];
		
		// The script for resizing
		$copyCodeBlock = (preg_match('/MSIE.*\)(?!Opera .*)$/', $_SERVER['HTTP_USER_AGENT'])) ? '<img src="includes/highlight_code.php?file=copy" alt="Kopieren" height="9" width="9" onclick="hl_copyClipboard(document.getElementById(\''.
			 'code'.$codeTagId.'\'));" />&nbsp;' : '';
		$openCode = str_replace('Code:', $copyCodeBlock.'<img src="includes/highlight_code.php?file=plus" alt="Maximieren/Minimieren" height="9" width="9" onclick="this.src = changeCodeBlock(document.getElementById(\''.
			 'code'.$codeTagId.'\'));" /> Code:', $bbcode_tpl['code_open']);
					
		// Return the formated text
		return $openCode.
			'<div class="highlight" id="code'.$codeTagId.'" style="'.$overFlow.$blockHeight.';width:expression(document.body.clientWidth*.7);">'.
			'<span class="lines">'.$lines.'</span>'.
			'<code'.($lines == '' ? ' class="oneLiner"' : '').'>'.$text.'</code></div>'.
			$bbcode_tpl['code_close'];
	}
	
	/**
	* Function that replaces phpBB [code] function
	*
	* @return string
	* @param string $text
	* @param string $uid
	* @param array $bbcode_tpl
	*/	
	function bbencode_do_highlight($text, $uid, $bbcode_tpl)
	{
		// Highlight code tags
		bbencode_highlight_callback($bbcode_tpl);
		$text = preg_replace_callback('/\[code:1:'.$uid.'\](.*)\[\/code:1:'.$uid.'\]/siU', 'bbencode_highlight_callback', $text);
		
		// We do _always_ need our script to be sent out
		static $codeSent;
		if(!$codeSent)
		{
			// This script is for changing the size of a code box
			if(preg_match('/MSIE.*\)(?!Opera .*)$/', $_SERVER['HTTP_USER_AGENT']))
			{
				// Additionaly, this one resizes the code boxes so that IE < 5.5 displays
				// code correct
				$text .= '<script type="text/javascript">function changeCodeBlock(o) {if(o.style.overflow == "auto"){o.style.overflow="";o.style.width="";o.style.height="";return "includes/highlight_code.php?file=minus";}else{o.style.overflow = "auto";o.style.width=document.body.clientWidth*.7;if(o.offsetHeight)o.style.height=Math.min(o.offsetHeight + 17, 400)+"px";else o.style.height = "400px";return "includes/highlight_code.php?file=plus";}}function hl_copyClipboard(o){if(!confirm("Codebox in Zwischenablage kopieren?"))return;if(!clipboardData.setData("text",o.firstChild.firstChild.firstChild.childNodes[1].innerText))alert("Kopieren fehlgeschlagen");}'.
					'function codeIE(){if(navigator.appVersion.match(/MSIE (5\.0|[1-4])/)){d=document.getElementsByTagName("DIV");for(i=0;i<d.length;i++)if(d[i].childNodes[1]&&d[i].childNodes[1].tagName=="CODE"){b=d[i].childNodes[1].innerText.split("\n");m=0;for(g=0;g<b.length;g++)if(b[g].length>m)m=b[g].length;d[i].childNodes[1].style.width=m*7+100;}}}'.
					'window.setTimeout("codeIE();", 10);'.
					'</script>';
			}
			else 
				$text .= '<script type="text/javascript">function changeCodeBlock(o) {if(o.style.overflow == "auto"){o.style.overflow="";o.style.width="";o.style.height="";return "includes/highlight_code.php?file=minus";}else{o.style.overflow = "auto";o.style.width=document.body.clientWidth*.7;if(o.offsetHeight)o.style.height=Math.min(o.offsetHeight, 400)+"px";else o.style.height = "400px";return "includes/highlight_code.php?file=plus";}}</script>';	
		}
		
		$codeSent = true;
		
		return $text;
	}
	
	/** Code for serving the images/css to the user **************************/
	
	// If called directly, output CSS or images
	if(basename($_SERVER['PHP_SELF']) == basename(__FILE__))
	{
		switch($_GET['file'])
		{
			case 'minus':
				header('Content-type: image/gif');
				die(base64_decode('R0lGODlhCQAJAJEAAAAAAP///+/v7////yH5BAEAAAMALAAAAAAJAAkAAAIQhI+iK8brXgPzTHllfKiDAgA7'));
			case 'plus':
				header('Content-type: image/gif');
				die(base64_decode('R0lGODlhCQAJAJEAAAAAAP///+/v7////yH5BAEAAAMALAAAAAAJAAkAAAIRhI+iK7bwoJINIktzjizeUwAAOw=='));
			case 'copy':
				header('Content-type: image/gif');
				die(base64_decode('R0lGODlhCQAJAIAAAO/v7wAAACH5BAAAAAAALAAAAAAJAAkAQAIRjI+JAMFsYGyO1vkkzLPqDBUAOw=='));
			default:
				header('Content-type: text/css');
				$hl_class = new highlighter();
				die($hl_class->put_default_css());	
		}
	}
	
	/** Debugging functions for this script **************************************
	function extractCSSKeywords()
	{
		// Get the keyword file for CSS2
		$cssKeywords = file_get_contents('http://www.w3.org/TR/CSS21/propidx.html');
		// Filter keywords
		preg_match_all('/((?<=html#propdef-)[^"]+|(?<=html#value-def-)[^"]+|(?<=>|\| )[A-Z]+(?=<| \|))/i', $cssKeywords, $arrayCssKeywords);
		$arrayCssKeywords[0] = array_unique($arrayCssKeywords[0]);
		
		echo(count($arrayCssKeywords[0]).' keywords found'."\n\n");
		$arrayList = '';
		foreach($arrayCssKeywords[0] as $cssKeyword)
		{
			$cssKeyword = urldecode($cssKeyword);
			$arrayList .= "'".$cssKeyword."', ".
				($n++ % 5 == 0 ? "\n" : '');
		}
		$arrayList = substr($arrayList, 0, -2);
		
		die($arrayList);
	}
	extractCSSKeywords();
	
	/*****************************************************************************/
	
?>