<?php
	/*
		Project_CMS

		Mode: Delete chancgelog
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/	
	
	// Security check
	cms_functions::inside_cms();
	
	// Never cache this page (Not really needed here, but who knows...)
	$cms_cache->set_dont_cache_flag();
	
	// Only admins are permitted to do that
	$cms_users->requirePermission('admin');
	
	$article = !empty($_REQUEST['article']) ? $_REQUEST['article'] : 'index';
	if(!file_exists(CMS_DATA_PATH.'/article_'.urlencode($article)))
		trigger_error(cms_functions::string('generic.404'), E_USER_ERROR);
	
	// Delete the changelog
	$article_object = new cms_article($article);
	$article_object->author = $cms_users->currentUserNick;
	$article_object->clearChanges();
	
	// Delete the cached versions of the file
	$cms_cache->clear_cache('article='.$article);
	if($article == 'index')
		$cms_cache->clear_cache('index.php-.html');
	
	cms_functions::redirect(array('article' => $article));

	// Write a log entry
	$cms_eventlog->write_log(sprintf(cms_functions::string('clearchangelog.deleted'), $_REQUEST['article']),
		cms_functions::generate_url(array('article' => $_REQUEST['article'])));
?>