<?php
	/*
		Project_CMS

		Mode: Delete a page
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/	
	
	// Security check
	cms_functions::inside_cms();
	
	// Never cache this page (Not really needed here, but who knows...)
	$cms_cache->set_dont_cache_flag();
	
	if($_REQUEST['article'] == 'index')
		trigger_error(cms_functions::string('delete.noindex'), E_USER_ERROR);
	if(!file_exists(CMS_DATA_PATH.'/article_'.urlencode($_REQUEST['article'])))
		trigger_error(cms_functions::string('generic.404'), E_USER_ERROR);
		
	$article = $_REQUEST['article'];
	
	// Permission for deleting a page
	$cms_users->requirePermission('delete');
	
	// Delete the attachments
	$article_object	= new cms_article($article);
	
	if($attachments = $article_object->getAttachments())
	foreach($attachments as $attachmentFile => $attachmentData)
		unlink(CMS_PATH.'/'.$attachmentData['file']);
	
	// Delete the article
	$article_object = null;
	unlink(CMS_DATA_PATH.'/article_'.urlencode($_REQUEST['article']));
	
	// Delete the rating file for the article (If exists)
	if(file_exists(CMS_DATA_PATH.'/article_rating_'.urlencode($_REQUEST['article'])))
		unlink(CMS_DATA_PATH.'/article_rating_'.urlencode($_REQUEST['article']));
	
	// Delete the cache for the article
	$cms_cache->clear_cache('article='.$_REQUEST['article']);
	
	// Clear cache for RSS feet
	$cms_cache->clear_cache('mode=rss');
			
	// Write into logfile
	$cms_eventlog->write_log('Artikel '.$_REQUEST['article'].' gelscht',
		cms_functions::generate_url());
		
	cms_functions::redirect();
	die();		
?>