<?php
	/*
		Project_CMS

		Mode: List of all pages
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/	
	
	// Security check
	cms_functions::inside_cms();
		
	// This page is for authors only
	$cms_users->requirePermission('edit');
	
	$order = isset($_REQUEST['order']) ? $_REQUEST['order'] : 'time';
	
	// Some orders need a special handling
	if($order == 'comment_time')
		// Order by latest comment
		$articles = cms_functions::get_dir(CMS_DATA_PATH, '/^article_rating_(.*)$/', 'time');
	elseif($order == 'asinsearch')
	{
		// Search for an article
		$sArticles 		= cms_functions::get_dir(CMS_DATA_PATH, '/^article_(?!rating)(.*)$/');
		$articles		= array();
		
		foreach($sArticles as $article)
		{
			$article		= urldecode($article);
			$article_object	= new cms_article($article);
			
			$matches = true;
			foreach(preg_split('/\s+/', $_REQUEST['search']) as $keyword)
				$matches &= stripos($article_object->text, $keyword) !== false;
				
			if($matches)
				$articles[] = $article;
		}
	}
	else
		// Normal ordering
		$articles = cms_functions::get_dir(CMS_DATA_PATH, '/^article_(?!rating)(.*)$/', $order);
		
	if($articles)
	foreach($articles as $article)
	{		
		$article		= urldecode($article);
		$article_object = new cms_article($article);
		
		$article_author					= $article_object->author;
		$article_text					= preg_replace('/\s+/si', ' ', substr(strip_tags($article_object->text), 0, 200).'...');
		$article_last_change_author 	= $article_object->changeLog[count($article_object->changeLog)-1]['user'];
		$article_last_change_comment 	= $article_object->changeLog[count($article_object->changeLog)-1]['comment'];
		
		$voting_file					= CMS_DATA_PATH.'/article_rating_'.urlencode($article);
		$voting_object 					= new cms_data_storage($voting_file);
		$article_comments 				= $article_object->getVotingsState() ?
			(isset($voting_object->data['comments']) ? count($voting_object->data['comments']) : 0) :
			'-';
			
		eval($cms_tpl->tpl('pagelist.page'));
	}
	
	$pageContent = eval($cms_tpl->tpl('pagelist'));
	$pageTitle	 = cms_functions::string('listpages.title');
?>