<?php
	/*
		Project_CMS

		Mode: Create a new article
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/	
	
	// Security check
	cms_functions::inside_cms();
	
	// Never cache this page (Not really needed here, but who knows...)
	$cms_cache->set_dont_cache_flag();
	
	// Permission for creating a new page
	$cms_users->requirePermission('new');
	
	if(isset($_REQUEST['article']))
	{
		if(file_exists(CMS_DATA_PATH.'/article_'.urlencode($_REQUEST['article'])))
			trigger_error(cms_functions::string('new.exists'), E_USER_ERROR);
		
		// Create file
		$article = $_REQUEST['article'];
		file_put_contents(CMS_DATA_PATH.'/article_'.urlencode($article), serialize(array()));
		
		// Wrtie log
		$cms_eventlog->write_log('Artikel '.$_REQUEST['article'].' erstellt',
			cms_functions::generate_url(array('article' => $_REQUEST['article'])));
		
		// Clear the cache of "listpages"
		$cms_cache->clear_cache('mode=listpages');
		// Clear cache for RSS feet
		$cms_cache->clear_cache('mode=rss');
		
		// Change to editing page
		cms_functions::redirect(array('article' => $_REQUEST['article'], 'mode' => 'edit'));
		die();	
	}
	
	$preset			= isset($_REQUEST['preset']) ? htmlspecialchars($_REQUEST['preset']) : '';
	$pageContent 	= eval($cms_tpl->tpl('edit_new'));
	$pageTitle		= 'Neuer Artikel';
?>