<?php
	/*
		Project_CMS

		Mode: Output an RSS feet with the latest changes
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/	
	
	// Security check
	cms_functions::inside_cms();
		
	// This page doesn't use a template - RSS is a clear standard
	// which doesn't need any modification
	
	// Output XML headers & channel information
	header('Content-type: text/xml');
	echo(
		'<?xml version="1.0" encoding="ISO-8859-1" ?>'.PHP_EOL.
		'<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns="http://my.netscape.com/rdf/simple/0.9/">'.PHP_EOL.
		'<channel>'.PHP_EOL.
    	'<title>'.htmlspecialchars(cms_functions::string('rss.title')).'</title>'.PHP_EOL.
    	'<link>'.$cms_base_url.cms_functions::generate_url().'</link>'.PHP_EOL.
    	'<description>'.htmlspecialchars(cms_functions::string('rss.desc')).'</description>'.PHP_EOL.
		'</channel>'.PHP_EOL
		);
	
	// Output the 10 newest files
	$article_counter = 0;
	foreach(cms_functions::get_dir(CMS_DATA_PATH, '/^article_(?!rating)(.*)$/', 'time') as $article)
	{	
		if(++$article_counter > 10) break;
		$article		= urldecode($article);
		$article_object = new cms_article($article);
		
		$article_author					= $article_object->author;
		$article_text					= preg_replace('/\s+/si', ' ', substr(strip_tags($article_object->text), 0, 200).'...');
		$article_last_change_author 	= $article_object->changeLog[count($article_object->changeLog)-1]['user'];
		$article_last_change_comment 	= $article_object->changeLog[count($article_object->changeLog)-1]['comment'];
		$article_last_change_time		= $article_object->changeLog[count($article_object->changeLog)-1]['time'];
				
		echo(
			'<item>'.PHP_EOL.
    		'<title>'.htmlspecialchars($article.' ('.$article_last_change_author.': '.$article_last_change_comment).')</title>'.PHP_EOL.
    		'<author>'.htmlspecialchars($article_last_change_author).'</author>'.PHP_EOL.
    		'<pubDate>'.htmlspecialchars(date('r', $article_last_change_time)).'</pubDate>'.PHP_EOL.
		    '<link>'.$cms_base_url.cms_functions::generate_url(array('article' => $article)).'</link>'.PHP_EOL.
			'</item>'.PHP_EOL
			);
	}
	
	echo('</rdf:RDF>');
	die();
?>