<?php
	/*
		Project_CMS

		Mode: Templates
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/	
	
	// Security check
	cms_functions::inside_cms();
	
	// Never cache this page (Not really needed here, but who knows...)
	$cms_cache->set_dont_cache_flag();
	$cms_users->requirePermission('admin');

	// Load templates
	$cms_templates_file = new cms_data_storage(CMS_DATA_PATH.'/templates');
	$cms_templates_data = &$cms_templates_file->data;
	
	// Remove a template
	if(isset($_REQUEST['remove']))
	{
		// Delete
		unset($cms_templates_data[$_REQUEST['remove']]);
		
		// Save
		$cms_templates_file->save();
		
		// Clear cache
		$cms_cache->clear_cache('');
		
		// Write log
		$cms_eventlog->write_log(cms_functions::string('templates.logDeleted'), cms_functions::generate_url(array('mode' => 'templates')));
		
		// Redirect
		cms_functions::redirect(array('mode' => 'templates'));
	}
	
	// Save a new template if submitted
	if(isset($_REQUEST['new']))
	{
		// Validate regex
		if(@preg_match('/'.str_replace('/', '\\/', $_REQUEST['searchFor']).'/', '') === false)
			trigger_error('Invalid regex: '.$_REQUEST['searchFor'], E_USER_ERROR);
		
		// Add regex
		$cms_templates_data[$_REQUEST['searchFor']] = $_REQUEST['replaceBy'];
		
		// Save
		$cms_templates_file->save();
		
		// Clear cache
		$cms_cache->clear_cache('');
		
		// Write log
		$cms_eventlog->write_log(cms_functions::string('templates.logAdded'), cms_functions::generate_url(array('mode' => 'templates')));
		
		// Redirect
		cms_functions::redirect(array('mode' => 'templates'));
	}
	
	// Output templates
	foreach($cms_templates_data as $searchFor => $replaceBy)
		eval($cms_tpl->tpl('templates.template'));		
			
	$pageContent = eval($cms_tpl->tpl('templates'));
	$pageTitle	 = cms_functions::string('templates.title');	
?>