<?php
	/*
		Project_CMS

		Mode: View old version
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/	
	
	// Security check
	cms_functions::inside_cms();
	
	// This is for authors eyes only
	$cms_users->requirePermission('edit');
	
	// View the article
	$article = isset($_REQUEST['article']) ? $_REQUEST['article'] : 'index';
	if(!file_exists(CMS_DATA_PATH.'/article_'.urlencode($article)))
		trigger_error(cms_functions::string('generic.404'), E_USER_ERROR);
	
	$article_object = new cms_article($article);
	$article_text	= &$article_object->getVersion($_REQUEST['version']);
	$article_author	= &$article_object->author;
	$article_date	= date(cms_functions::string('generic.date'), $article_object->changeLog[count($article_object->changeLog)-1]['time']);
	
	$pageTitle		= sprintf(cms_functions::string('version.oldversiontitle'), $_REQUEST['article']);
	if(CMS_USE_WIKI_FORMATTING === true)
		$article_text	= cms_functions::wiki_format($article_text);
	$article_text	= cms_functions::parse_input($article_text);
	$pageContent 	= eval($cms_tpl->tpl('article'));		
?>