<?php
	/*
		Project_CMS

		Mode: Output changes in versions
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/	
	
	// Security check
	cms_functions::inside_cms();

	// This page is for authors eyes only
	$cms_users->requirePermission('edit');
	
	// Output article..
	$article = isset($_REQUEST['article']) ? $_REQUEST['article'] : 'index';
	if(!file_exists(CMS_DATA_PATH.'/article_'.urlencode($article)))
		trigger_error(cms_functions::string('generic.404'), E_USER_ERROR);
		
	// ..get changes..
	$article_object 	= new cms_article($article);
	if($_REQUEST['compareTo'])
	{
		if($_REQUEST['version']-1 > 0)
			$old_article_text	= &$article_object->getVersion($_REQUEST['version']-1);
		$new_article_txt	= &$article_object->getVersion($_REQUEST['version']);
	}
	else 
	{
		$old_article_text	= &$article_object->getVersion($_REQUEST['version']);
		$new_article_txt	= &$article_object->text;
	}
	$version_differ		= cms_versioning::html_diff($old_article_text, $new_article_txt);
	
	// ..and output :)
	$pageTitle			= sprintf(cms_functions::string('version.difference'), $_REQUEST['article']);
	$pageContent		= '<h2>'.$pageTitle.' (Version '.htmlspecialchars($_REQUEST['version']).')</h2>'.
							$version_differ;	
?>