<?php
	/*
		Project_CMS

		Mode: View article
		
		Copyright (c) 2005 by Phillip Berndt
		
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
	
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
	
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	*/	
	
	// Security check
	cms_functions::inside_cms();

	// View article
	$article = isset($_REQUEST['article']) ? $_REQUEST['article'] : 'index';
	if($article == '__homepage__')
	{
		$article = 'author_'.$cms_users->currentUserNick;
		
		$cms_cache->set_dont_cache_flag();
		cms_functions::redirect(array('article' => $article));
		die('Redirect: '.$article);
	}
	
	if(!file_exists(CMS_DATA_PATH.'/article_'.urlencode($article)))
	{
		// If permitted to do so, create the article
		$cms_cache->set_dont_cache_flag();
		if($cms_users->checkPermission('new'))
		{
			$cms_cache->set_dont_cache_flag();
			cms_functions::redirect(array('mode' => 'new', 'preset' => $article));
			die();
		}
		trigger_error(cms_functions::string('generic.404'), E_USER_ERROR);
		die();
	}
	
	// Load article
	$article_object = new cms_article($article);
		
	// Output article
	$article_text	= &$article_object->text;
	$article_author	= &$article_object->author;
	$article_date	= date(cms_functions::string('generic.date'), $article_object->changeLog[count($article_object->changeLog)-1]['time']);
	
	// Are ratings active for this article?
	if($article_object->getVotingsState())
		include(CMS_MODES_PATH.'/view_rate.php');
		
	// If this is an article about an author, change the title
	if(substr($article, 0, 7) == 'author_')
		$article = sprintf(cms_functions::string('view.authortitle'), substr($article, 7));
		
	if(CMS_USE_WIKI_FORMATTING === true)
		$article_text	= cms_functions::wiki_format($article_text);
	$article_text	= cms_functions::parse_input($article_text);
	
	// Load the title for the page
	$pageTitle		= ucwords($article);
	if(preg_match_all('/(?<=<h2>).+?(?=<\/h2>)/i', $article_text, $h2Tags, PREG_SET_ORDER) && count($h2Tags) == 1)
		$pageTitle = $h2Tags[0][0];
	
	// Return the page
	$pageContent 	= eval($cms_tpl->tpl('article'));	
?>