/*
	Project_CMS
	Copyright (c) 2005 by Phillip Berndt [www.pberndt.com]
	
	Erweiterte <TEXTAREA> fr Browser
	Funktioniert in Micro$oft Internet Explorer und Firefox
	
	Features:
		- Erlaubt es, in <TEXTAREA> Elementen per <TAB> Tabstopps zu setzen
		- Vervollstndigt schlieende XML Tags nach der Eingabe von </>
		- Rckt neue Zeilen automatisch ein
		- Erlaubt es, eingegebenen Text nach HTML konvertieren zu lassen
		- Erlaubt es, automatisch TOCs zu generieren
		
	Auerdem enthalten:
		- Validator fr den Editor
	
	Bekannte Bugs:
		- Die Vervollstndigung hat Probleme mit ungltigem XML
		
	Lizenz:
		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
*/

// Prfen der Form auf Vollstndigkeit
function formEnableValidator()
{
	document.forms[0].raisedByChange = false;
	document.forms[0].orginalText = document.forms[0].text.value;
	
	document.forms[0].change.onclick = function()
	{	
		this.parentNode.parentNode.raisedByChange = true;
	}
	document.forms[0].do_upload.onclick = function()
	{	
		this.parentNode.parentNode.raisedByChange = false;
	}
	document.forms[0].onsubmit = function()
	{
		if(this.raisedByChange != true)
			return true;
		
		if(this.comment.value == "")
		{
			alert("Bitte einen Kommentar angeben");
			this.comment.focus();
			return false;
		}
		
		if(this.orginalText == this.text.value)
		{
			alert("Bitte etwas am Text ndern");
			this.text.focus();
			return false;
		}
		
		return true;
	}
}

// Damit warten, bis die HTML Struktur steht
// Nicht per onload, das knnte anderweitig belegt sein
// Lieber ein Timeout setzen
window.setTimeout("formEnableValidator();", 200);

/********************************************************************/

// Funktion zum Exportieren eines DOM Dokumentes zu XML Quellcode
function getNodeSource(node)
{
	// Node-Daten anfgen
	switch(node.nodeType)
	{
		case 1: // Element
		case 9: // Document
			retVal = "<" + node.nodeName + " ";
			if(node.hasAttributes())
			{
				for(node._temporaryAttributeIterator=0; node._temporaryAttributeIterator<node.attributes.length; node._temporaryAttributeIterator++)
				{
					attribute = node.attributes.item(node._temporaryAttributeIterator);
					retVal += attribute.nodeName + '="' + attribute.nodeValue.replace(/"/g, '&quot;') + '"' // ');
				}
				node._temporaryAttributeIterator = null;
			}
			
			if(node.hasChildNodes)
			{
				retVal += ">";
				
				for(node._temporaryIterator=0; node._temporaryIterator<node.childNodes.length; node._temporaryIterator++)
				{
					retVal += getNodeSource(node.childNodes[node._temporaryIterator]);
				}
				node._temporaryIterator = null;
				
				retVal += "</" + node.nodeName + ">";
			}
			else
			{
				retVal += "/>";
			}
			break;
		case 3: // Text
			retVal = node.nodeValue;
			break;
		case 4: // CData
			retVal += "<![CDATA[ " + node.nodeValue + "]]>";
			break;
		case 8: // Comment
			retVal = "<!-- " + node.nodeValue + " -->";
			break;
		case 10: // Document type
			// Ignore
			break;
		default:
			alert("Puu! What is a " + node.nodeName + " ("+ node.nodeType + ")");
			retVal = "";
	}
		
	return retVal;
}

/********************************************************************/

// Alle Textarea Elemente automatisch ndern
function changeTextareaElements()
{
	document.textAreas = document.getElementsByTagName("textarea");
	for(i=0; i<document.textAreas.length; i++)
	{
		document.textAreas[i].textAreaID = i;
		makeAdvancedTextArea(document.textAreas[i]);
		document.textAreas[i].focus();
	}
}

// Damit warten, bis die HTML Struktur steht
// Nicht per onload, das knnte anderweitig belegt sein
// Lieber ein Timeout setzen
window.setTimeout("changeTextareaElements();", 200);

// Diese Funktion wandelt eine Textarea in das "verbesserte" Element um
// Tatschlich fgt sie nur ein paar Javascripte ein..
function makeAdvancedTextArea(textArea)
{
	if(textArea.tagName.toUpperCase() != "TEXTAREA")
		return false;
	
	// OnBlur wird beim Verlassen aufgerufen
	// z.B. beim Drcken von <TAB>. Ist ein bestimmtes Bit gesetzt,
	// diesen Wechsel verbieten.
	textArea.onblur = function(e)
	{
		if(!this.dontLeave) return;
		this.dontLeave = null;
		window.setTimeout("document.textAreas[" + this.textAreaID + "].restoreFocus()", 1);
		return false;
	}
	
	// Diese Funktion setzt den Fokus zurck auf das Element und setzt zudem
	// den Cursor an die richtige Stelle
	textArea.restoreFocus = function()
	{
		this.focus();
		
		if(this.caretPos)
		{
			this.caretPos.collapse(false);
			this.caretPos.select();
		}
	}
	
	// Funktion zum Ermitteln der aktuellen Cursorposition
	textArea.getCursorPos = function()
	{
		// Die aktuelle Cursorposition ermitteln
		// Im IE recht umstndlich
		if(this.selectionStart)
			currPos = this.selectionStart;
		else if(this.caretPos)
		{
			oldText = this.caretPos.text;
			finder = "--getcurrpos" + Math.round(Math.random() * 10000) + "--";
			this.caretPos.text += finder;
			currPos = this.value.indexOf(finder);
			
			this.caretPos.moveStart('character', -finder.length);
			this.caretPos.text = "";
			
			this.caretPos.scrollIntoView(true);
		}
		else return;
		
		return currPos;
	}
	
	// Bei <TAB> einen Tabulator einfgen
	// Ansonsten prfen, ob </> getippt wird
	textArea.onkeydown = function(e)
	{
		if(this.selectionStart == null &! this.createTextRange)
			return;
		if(!e) e = window.event;
		
		// Tabstopp
		if(e.keyCode == 9)
		{
			this.dontLeave = true;					
			this.textInsert(String.fromCharCode(9));
		}
		
		// Neue Zeile
		if(e.keyCode == 13)
		{
			// Die Curosrposition ermitteln
			currPos = this.getCursorPos();
			
			// Die letzte Zeile suchen
			lastLine = "";
			for(i=currPos-1;i>=0;i--)
			{
				if(this.value.substring(i, i + 1) == '\n') break;
			}
			lastLine = this.value.substring(i + 1, currPos);
			
			// In dieser Zeile Whitespace suchen
			whiteSpace = "";
			for(i=0;i<lastLine.length;i++)
				if(lastLine.substring(i, i + 1) == '\t') whiteSpace += "\t";
				else if(lastLine.substring(i, i + 1) == ' ') whiteSpace += " ";
				else break;
			
			// Der Internet Explorer bentigt ein weiteres mal ne Extrawurst
			if(navigator.appVersion.match(/MSIE/))
				whiteSpace = "\\n" + whiteSpace;
			
			// Whitespace einfgen
			window.setTimeout("document.textAreas["+this.textAreaID+"].textInsert(\""+whiteSpace+"\");", 1);
		}
		
		// Nur bei Zeichen ab dem Leerzeichen
		if(e.keyCode >= 32)
		{
			// keyCode debug:
			//if(e.altKey == 1) alert(e.keyCode);
			
			// Preview
			if(e.keyCode == 80 && e.altKey == 1)
			{
				// This code does NOT create a valid text/xml document yet			
				previewWindow = window.open("", "preview");
				previewWindow.document.open();
				previewWindow.document.write(
					getNodeSource(document.lastChild).
						replace(
							getNodeSource(document.getElementById("content")),
							'<div id="content">' +
							this.value.replace(/(<code[^>]+>)([^\0]+?)<\/code>/g, function(a, b, c) { return b + c.replace(/</g, "&lt;").replace(/\n/g, "<br/>").replace(/  |\t/g, "&nbsp; ") + "</code>"; }) +
							+ '</div>'
						).
						replace(
							getNodeSource(document.getElementsByTagName("title")[0]),
							"<title>Preview</title>"
						)
					);

				previewWindow.document.close();
			}
			
			// TOC erstellen
			if(e.keyCode == 89 && e.altKey == 1)
			{
				// Alle berschriften laden
				regExp = /<h3( id="([^"]+)")?>(.+?)<\/h3>/i;
				test = this.value;
				toc = "<ul>\n";
				
				while(match = regExp.exec(test))
				{
					id = match[2];
					title = match[3];
					
					if(!id)
						toc += ' <li>' + title + '</li>' + "\n";
					else
						toc += ' <li><a href="#' + id + '">' + title + '</a></li>' + "\n";
					
					test = test.replace(regExp, "");
				}
				
				toc += "</ul>";
				
				this.textInsert(toc);
			}
			
			// HTMLize ausfhren
			if(e.keyCode == 88 && e.altKey == 1)
			{
				// Die aktuelle Selektion laden
				if(this.selectionStart != null)
				{
					selectionText = this.value.substr(this.selectionStart, this.selectionEnd - this.selectionStart);
				}
				else if(this.caretPos)
				{
					selectionText = this.caretPos.text;
				}
				else return;
				
				if(selectionText == "") return;
				
				// In HTML umwandeln
				// Einrckungen
				indent = selectionText.match(/^(\s*)/)[1];
				selectionText = selectionText.replace(new RegExp("^(.+)$", "gm"), "	$1");
				// Zeilenumbrche
				maxWidth = Math.floor(this.offsetWidth / 10) - 10;
				
				lineBreak = new RegExp("^(\r?\n?)(\\s*)(.{" + maxWidth + "}\\S*)\\s(.{5,})$", "mg");
				while(selectionText.match(lineBreak))
					selectionText = selectionText.replace(lineBreak, "$1$2$3\r\n$2$4");
				
				// Sonderzeichen im Text konvertieren
				selectionText = selectionText.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
				selectionText = selectionText.replace(new RegExp("\n\n+", "g"), "\n" + indent + "</p>\n" + indent + "<p>\n");
				selectionText = indent + "<p>\n" + selectionText + "\n" + indent + "</p>\n";
				// Hyperlinks umwandeln
				selectionText = selectionText.replace(/(http:\/\/\S+)/gi, "<a href=\"$1\">$1</a>");
				
				// Und einfgen
				this.textInsert(selectionText);
				
				return;
			}
			
			// Ist dies ein "<"?
			if(e.keyCode == 226 && e.shiftKey == 0)
				this.tagStart = 1;
			// Ist dies ein "/"?
			else if(this.tagStart == 1 && e.keyCode == 55)
				this.tagStart = 2;
			// Ist dies ein ">"?
			else if(this.tagStart == 2 && e.keyCode == 226 && e.shiftKey == 1)
			{
				this.tagStart = 0;
						
				// Die Curosrposition ermitteln
				currPos = this.getCursorPos();
				
				// Offene Tags suchen
				regexTagMatcher = new RegExp("<([A-Z:0-9_\-]+)[^/]*>", "i");
				testPos = currPos - 1;
				
				textFromBeginning = this.value.substr(0, currPos);
				textFromBeginning = textFromBeginning.replace(new RegExp("\r\n", "g"), "  ");
				while(textFromBeginning.match(/<([A-Z:0-9_\-]+)[^>\/]*>(.*)<\/\1>/i))
					textFromBeginning = textFromBeginning.replace(/<([A-Z:0-9_\-]+)[^>\/]*>(.*)<\/\1>/i, "$2");
				
				// Prfen, ob diese Tags evntl. schon wieder geschlossen sind
				while(--testPos >= 0)
				{
					textToCurrPos = textFromBeginning.substr(testPos);
					var regexMatch = regexTagMatcher.exec(textToCurrPos);
					
					if(regexMatch)
					{
						tagName = regexMatch[1];
						
						if(textToCurrPos.toLowerCase().indexOf("</"+tagName.toLowerCase()+">") != -1)
							continue;
							
						if(this.createTextRange)
							this.caretPos = document.selection.createRange().duplicate();
			
						// Wenn nein, den schlieenden Tag einfgen
						this.textInsert(tagName);
						
						return true;
					}
				}
				
			}
			else
				this.tagStart = 0;
		}
	}
	
	// Die aktuelle Cursorposition im IE speichern
	textArea.onkeyup = textArea.onclick = textArea.onselect = function(e)
	{
		if(this.createTextRange)
			this.caretPos = document.selection.createRange().duplicate();
	}
	
	// Text an der aktuellen Cursorposition einfgen
	textArea.textInsert = function(insertText)
	{				
		if(this.selectionStart != null)
		{
			var savedScrollTop = this.scrollTop;
			var begin = this.selectionStart;
			var end = this.selectionEnd;
			if(end > begin + 1)
				this.value = this.value.substr(0, begin) + insertText + this.value.substr(end);
			else
				this.value = this.value.substr(0, begin) + insertText + this.value.substr(begin);
	
			this.selectionStart = begin + insertText.length;
			this.selectionEnd	= begin + insertText.length;
			this.scrollTop = savedScrollTop;
		}
		else if(this.caretPos)
		{
			this.caretPos.text = insertText;
			this.caretPos.scrollIntoView(true);
		}
		else(text.value += insertText);
		
		this.focus();
	}
}